// window.addEventListener("load", function() {
// 	setHtmlAttr();
// })
// window.addEventListener('resize', function() {
// 	setHtmlAttr();
// })
var href = location;
var host = href.origin;
var search = href.search;
var hospitalParams = {}; // 医院相关参数
// host = "https://test.youyidacare.com"
var apiUrl = host + '/youyida/';
// var apiUrl = 'https://test.youyidacare.com/youyida/';

var api = {
    getInfo: "noAuth/client/patient/getOrderInfo/", // /noAuth/client/patient/getOrderInfo/{orderId}/{doctorId}   查看订单资料
    submitInfo: "noAuth/client/patient/addDoctorForGroup", // 提交信息
    imgUrl: "common/getOrderPicture/",
    getServiceTel: "common/getServiceTel",
    rejectGroup: "/noAuth/client/patient/rejectGroup", // 拒绝邀请
    getTitles: '/common/getTitles',
    getDepartments: '/common/getDepartments',
    getCode: 'sms/getLoginCode/',
	getGroupTitles:'/common/getGroupTitles'
}

var orderInfo = {};

let count = 60;

function setHtmlAttr() {
    if (window.innerWidth > 750) {
        $("html").attr("rem", 1920);
    } else {
        $("html").attr("rem", 750);
    }
}

var searchObj = (function() {
    var search = location.search.slice(1);
    search = search.split('&');
    var obj = {};
    search.forEach(v => {
        var arr = v.split("=");
        obj[arr[0]] = arr[1];
    })
    return obj;
})()


$(function() {
    // 获取订单信息
    $.ajax({
        url: apiUrl + api.getInfo + searchObj.orderId + "/" + searchObj.doctorId,
        type: "get",
        dataType: "json",
        context: this,
        success: function(res) {
            let data = res.result;
            orderInfo = data;
            setPageData(data);
        },
    })
    // 获取客服电话
    $.ajax({
        url: apiUrl + api.getServiceTel,
        type: "get",
        dataType: "json",
        context: this,
        success: function(res) {
            let data = res.result;
            $(".service-phone").text("如需帮助可联系客服：" + data);
        },
    })

    $.ajax({
        url: apiUrl + api.getGroupTitles,
        type: "get",
        dataType: "json",
        context: this,
        success: function(res) {
            for (var i = 0; i < res.result.length; i++) {
                $('#titleSelect').append('<option value="' + res.result[i].id + '">' + res.result[i]
                    .title + '</option>')
            }
        },
    })

    $.ajax({
        url: apiUrl + api.getDepartments,
        type: "get",
        dataType: "json",
        context: this,
        success: function(res) {
            for (var i = 0; i < res.result.length; i++) {
                $('#departmentSelect').append('<option value="' + res.result[i].id + '">' + res
                    .result[i].name + '</option>')
            }
        },
    })

    $(".input").on("blur", function(e) {
        if (!$(this).val()) {
            $(this).nextAll(".error-tips").css("display", "block");
        } else {
            $(this).nextAll(".error-tips").css("display", "none");
        }
        if ($(this).attr("name") === "mobilephone") {
            validateMobile($(this));
        }
    })

    $("#code").on("click", function(e) {
        if ($("#mobilephone").val() === '') {
            alert('请输入电话')
            return false
        }
        $.ajax({
            url: apiUrl + api.getCode + $("#mobilephone").val(),
            type: "get",
            dataType: "json",
            context: this,
            success: function(res) {
                console.log(res);
                if (res.status !== 200) {
                    alert(res.message)
                }
            },
        })
        let timer = window.setInterval(function() {
            count--;
            $("#code").hide()
            $("#reCode").html(count + 's重新获取').show()
            if (count === 0) {
                $("#code").show()
                $("#reCode").hide()
                count = 60
                clearInterval(timer)
            }
        }, 1000)
    })

    $("#readed").on("click", function(e) {
        $(this).attr("checked", true)
    })

    $(".btn.reject").on("click", function(e) {
        $(".reject-tip").css("display", "block");
        $("#mask").css("display", "block")
    })

    $(".tip-btns .btn.reject").on("click", function(e) {
        $(".reject-tip").css("display", "none");
        $("#mask").css("display", "none")
    })

    $(".tip-btns .btn.pass").on("click", function(e) {
        var params = {
            id: searchObj.groupId,
            diagnosisPro: "",
            treatment: "",
            doctorStatus: -1,
            remarks: "",
            orderNumber: orderInfo.orderNumber
        }
        $.ajax({
            url: apiUrl + api.rejectGroup,
            type: "post",
            data: JSON.stringify(params),
            processData: false,
            contentType: 'application/json',
            dataType: "json",
            success: function(res) {
                $(".reject-tip").css("display", "none");
                $("#mask").css("display", "none");
                $('.success-tip').css('display', 'block').html('提交成功');
                setTimeout(() => {
                    $('.success-tip').css('display', 'none');
                }, 1500)
            },
        })
    })

    $("#doctor-form").on("submit", function(e) {
        e.preventDefault();
        if (!$("#readed").attr("checked")) {
            $('.success-tip').css('display', 'block').html('请阅读并同意相关协议');
            setTimeout(() => {
                $('.success-tip').css('display', 'none');
            }, 1500)
            return false;
        }
        var paramsStr = $(this).serializeArray();
        var params = setQueryParams(paramsStr)
        if (checkSubmitData(params)) {
            return false;
        }

        var submitData = {
            doctorHospital: params.hospital,
            doctorHospitalId: "",
            doctorName: params.doctorname,
            mobileNumber: params.mobilephone,
            orderId: searchObj.orderId,
            price: params.price,
            titleId: $('#titleSelect').val(),
            departmentId: $("#departmentSelect").val(),
            code: $("#codeValue").val()
        };
        console.log(submitData);
        $.ajax({
            url: apiUrl + api.submitInfo,
            type: "post",
            data: JSON.stringify(submitData),
            processData: false,
            contentType: 'application/json',
            dataType: "json",
            success: function(res) {
                if (res.status === 200) {
                    resData = res.result;
                    location.href = "https://www.nxyouyida.com";
                    $('.success-tip').css('display', 'block').html('提交成功');
                    setTimeout(() => {
                        $('.success-tip').css('display', 'none');
                    }, 1500)
                } else {
                    $('.success-tip').css('display', 'block').html(res.message);
                    setTimeout(() => {
                        $('.success-tip').css('display', 'none');
                    }, 1500)
                }
            },
            error: function(err) {

            }
        })
    })
})

function setQueryParams(params) {
    var obj = {};

    params.forEach(v => {
        obj[v.name] = v.value;
    })

    return obj;
}

function checkSubmitData(data) {
    let keys = Object.keys(data);
    let flag = false;
    for (var i = 0; i < keys.length; i++) {
        if (data[keys[i]] === "") {
            flag = true;
        }
    }
    return flag;
}

function validateMobile(mobileInput) {
    var reg = /^[1][1-9][0-9]{9}$/;
    var mobileNumber = mobileInput.val();
    if (mobileNumber.length === 0) {
        mobileInput.nextAll(".error-tips").html("请输入您的电话");
        mobileInput.nextAll(".error-tips").css("display", "block");
        return false;
    }
    if (mobileNumber.length > 0 && mobileNumber.length < 11) {
        mobileInput.nextAll(".error-tips").html("请输入11位的手机号码");
        mobileInput.nextAll(".error-tips").css("display", "block");
        return false;
    }
    if (!reg.test(mobileNumber)) {
        mobileInput.nextAll(".error-tips").html("手机号码格式不正确");
        mobileInput.nextAll(".error-tips").css("display", "block");
        return false;
    }
    mobileInput.nextAll(".error-tips").html("请输入手机号码");
    mobileInput.nextAll(".error-tips").css("display", "none");
    return true;
}

function setPageData(data) {
    var pictures = data.patientInfoVO.pictures;
    var patientName = data.patientInfoVO.name;
    var appeal = data.patientInfoVO.appeal;
    var allergyInd = data.patientInfoVO.allergyInd;
    var allergy = data.patientInfoVO.allergy;
    var geneticInd = data.patientInfoVO.geneticInd;
    var genetic = data.patientInfoVO.genetic;
    var age = data.patientInfoVO.age;
    var diseaseList = data.diagnosisList;
    var sex = setSex(data.patientInfoVO.sex);
    var fileName = data.fileDtos;
    var fileList = '';
    var disStr = "";
    var imgList = "";
    diseaseList.forEach(v => {
        disStr += `
			<span>${v.name}</span>
		`;
    })
    pictures.forEach(v => {
        imgList += `
			<img src="${apiUrl + api.imgUrl + v}" alt="img">
		`
    })
    fileName.forEach(el => {
        fileList += `
            <div>
              <a onClick="downloadFile('${el.url}','${el.name}')">${el.name}</a>
            </div>
        `
    })

    fileList = fileList === '' ? '无' : fileList
    var html = `
	<div class="patient-detail">
		<div class="patient-detail-item  inline">
			<div class="detail-item-label">${patientName} | ${sex} | ${age}岁</div>
			<div class="detail-item-content">
				<span class="long">过敏史：${allergyInd === 0 ? allergy : '无'}；</span>
				<span class="long">家族史：${geneticInd === 0 ? genetic : '无'}；</span>
			</div>
		</div>
		<div class="patient-detail-item inline">
			<div class="detail-item-label">诊断</div>
			<div class="detail-item-content">
				${disStr}
			</div>
		</div>
		<div class="patient-detail-item">
			<div class="detail-item-label long">病情自述</div>
			<div class="detail-item-content">
				<span>${appeal}</span>
			</div>
		</div>
		<div class="patient-imgs">
			${imgList}
		</div>
        <div class="file-list">
            其他附件：${fileList}
        </div>
	</div>
	`;
    $("#patientInfo").html(html);
}


function setSex(sex) {
    if (sex === 0) {
        return "男";
    } else if (sex === 1) {
        return "女";
    } else {
        return "未知";
    }
}

function downloadFile(url, fileName) {
    url = host + '/youyida/common/getOrderPicture/' + url
    const x = new XMLHttpRequest()
    x.open("GET", url, true)
    x.responseType = 'blob'
    x.onload = (e) => {
        const url = window.URL.createObjectURL(x.response)
        const a = document.createElement('a')
        a.href = url
        a.target = '_blank'
        a.download = fileName
        a.click()
        a.remove()
    }
    x.send()
}
